/*
 * Copyright (C) 2011 Kouichi Machida (k01-dev@live.jp)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.white_wing.android.appwidget.electricpowerconsumption;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

/**
 * 
 * 
 * @author Kouichi Machida
 */
public class ElectricPowerConsumptionAppWidgetProvider extends AppWidgetProvider {

	/**
	 * Õ^O\܂B
	 */
	private static final String TAG = "ElectricPowerConsumptionAppWidgetProvider";

	/**
	 * 
	 * 
	 * @param array
	 * @return
	 */
	private static String toString(int[] array) {
		StringBuilder tmp = new StringBuilder();

		tmp.append("[ ");

		for (int index = 0; index < array.length; index++) {
			tmp.append(array[index]);

			if ((index + 1) < array.length) {
				tmp.append(", ");
			}
		}

		tmp.append(" ]");

		return tmp.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.appwidget.AppWidgetProvider#onDeleted(android.content.Context, int[])
	 */
	@Override
	public void onDeleted(Context context, int[] appWidgetIds) {
		super.onDeleted(context, appWidgetIds);

		// LOG:
		Log.v(TAG, "void onDeleted(Context, int[])");
		Log.v(TAG, String.format("appWidgetIds = %s", toString(appWidgetIds)));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.appwidget.AppWidgetProvider#onDisabled(android.content.Context)
	 */
	@Override
	public void onDisabled(Context context) {
		super.onDisabled(context);

		// LOG:
		Log.v(TAG, "void onDisabled(Context)");

		// T[rXI܂B
		context.stopService(new Intent(context, ElectricPowerConsumptionAppWidgetService.class));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.appwidget.AppWidgetProvider#onEnabled(android.content.Context)
	 */
	@Override
	public void onEnabled(Context context) {
		super.onEnabled(context);

		// LOG:
		Log.v(TAG, "void onEnabled(Context)");

		// T[rXN܂B
		context.startService(new Intent(context, ElectricPowerConsumptionAppWidgetService.class));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.appwidget.AppWidgetProvider#onUpdate(android.content.Context, android.appwidget.AppWidgetManager, int[])
	 */
	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		super.onUpdate(context, appWidgetManager, appWidgetIds);

		// LOG:
		Log.v(TAG, "void onUpdate(Context, AppWidgetManager, int[])");
		Log.v(TAG, String.format("appWidgetIds = %s", toString(appWidgetIds)));

		context.startService(new Intent(ElectricPowerConsumptionAppWidgetService.ACTION_APPWIDGET_INVALIDATE, null, context, ElectricPowerConsumptionAppWidgetService.class));
	}

}
